# -*- coding: utf-8 -*-
from setuphelpers import *
from setupdevhelpers import *


def update_package():
    # Declaring local variables
    package_updated = False
    proxies = get_proxies_from_wapt_console()
    if not proxies:
        proxies = get_proxies()

    update_dict = {
        "os_archi": {
            "x64": "x86_64",
            "arm" : "arm64"
        },
    }

    url = "https://cran.r-project.org/bin/macosx/"
    archi = update_dict["os_archi"][control.architecture]

    # Getting latest version from official sources
    print("URL used is: %s" % url)
    for bs_search in bs_find_all(url, "h2", proxies=proxies):
        version = bs_search.text.split(" ")[1]
        latest_bin = f"R-{version}-{archi}.pkg"
        download_url = f"https://cran.r-project.org/bin/macosx/big-sur-{archi}/base/R-{version}-{archi}.pkg"
        break


    # Deleting outdated binaries
    remove_outdated_binaries(latest_bin)

    # Downloading latest binaries
    print("Latest %s version is: %s" % (control.name, version))
    print("Download URL is: %s" % download_url)
    if not isfile(latest_bin):
        print("Downloading: %s" % latest_bin)
        wget(download_url, latest_bin, proxies=proxies)
    else:
        print("Binary is present: %s" % latest_bin)

    control.set_software_version(version)
    control.save_control_to_wapt()

    # Validating or not update-package-sources
    return package_updated
